//     (  range- .)

#include "ACDecod.h"
#include "pngpvt.h"
#include "pngdecod.h"

typedef unsigned int uint;
#define  DO(n)	for (int _=0; _<n; _++)
const uint TOP=1<<24;
const uint lenRange=1<<15;

ACDecoder::ACDecoder ()
{
  freq = new uint [PngMaxNumberOfHuffmanCodes] ;
  sumPprFreq = new uint [PngMaxNumberOfHuffmanCodes] ;
  buffer= new UBYTE1[CompressedBufferSize+5];
  inCode= new UBYTE1[lenRange];

  return ;
}

ACDecoder::~ACDecoder ()
{
  delete [] freq ; freq = NULL ;
  delete [] sumPprFreq ; sumPprFreq = NULL;
  delete [] buffer ; buffer = NULL ;
  delete [] inCode ; inCode = NULL ;
  return ;
}

//      [0; 2^15-1]    

void ACDecoder::StartDecod(PngDecoder &decoder, unsigned int lengthcount, const unsigned int huffbits [])
 {bool nayavnoCode=false;
  uint i;
  UBYTE4 sumFreq=0, currentFreq;
  for (i=0; i<lengthcount; i++)
   if (huffbits[i])
    {nayavnoCode=true;
     break;
    }
  if (!nayavnoCode) //  -   
   return;
  memset (freq, 0, sizeof (*freq) * PngMaxNumberOfHuffmanCodes);
  if (decoder.bit_offset<8)
   decoder.GetBits(8-decoder.bit_offset); //   
  //  
  sumFreq=0;
  for (i=0; i<lengthcount; i++)
   if (huffbits[i])
    {currentFreq=(1<<(huffbits[i]-1)) | decoder.GetBits(huffbits[i]-1);
     freq[i]=currentFreq;
     sumPprFreq[i]=sumFreq;
     memset(inCode+sumFreq, i, currentFreq);
     sumFreq+=currentFreq;
    }
  if (sumFreq>lenRange)
   throw EPngError ("No corect frequencies AC") ;
  for (i=lengthcount; i<PngMaxNumberOfHuffmanCodes; i++)
   sumPprFreq[i]=sumFreq;
  if (decoder.bit_offset<8)
   decoder.GetBits(8-decoder.bit_offset); //   
  UBYTE4 lenBuffer;
  lenBuffer=decoder.GetBits(16);
  if (lenBuffer>CompressedBufferSize)
   throw EPngError ("No corect size buffer AC") ;
  for (i=0; i<lenBuffer; i++)
   buffer[i]=decoder.GetIDATByte();
  // 
  code=0;
  pozBuffer=0;
  range=(uint)-1;
  DO(5) code=(code<<8) | buffer[pozBuffer++];
 }

int ACDecoder::Decode ()
 {int index = code / (range>>=15);
  if (index>=sumPprFreq[256])
   index=inCode[index]+256;
  else
   index=inCode[index];
  code -= sumPprFreq[index]*range;
  range *= freq[index];
  while( range<TOP ) code=(code<<8)|buffer[pozBuffer++], range<<=8;
  return index;
 }

