//     (  range- .)

#include "acencod.h"
#include "pngpvt.h"
#include "pngencod.h"

typedef unsigned int  uint;
#define  DO(n)	   for (int _=0; _<n; _++)
const uint TOP=1<<24;
const uint lenRange=1<<15;

int countBit(UBYTE4 diapazon)
 {if (diapazon==0)

   return 0;

  if (diapazon==1)

   return 1;

  if (diapazon<=3)

   return 2;

  if (diapazon<=7)

   return 3;

  if (diapazon<=15)

   return 4;

  if (diapazon<=31)

   return 5;

  if (diapazon<=63)

   return 6;

  if (diapazon<=127)

   return 7;

  if (diapazon<=255)

   return 8;

  if (diapazon<=511)

   return 9;

  if (diapazon<=1023)

   return 10;

  if (diapazon<=2047)

   return 11;

  if (diapazon<=4095)

   return 12;

  if (diapazon<=8191)

   return 13;

  if (diapazon<=16383)

   return 14;

  return 15;

 }


ACEncoder::ACEncoder ()
{
  freq = new uint [PngMaxNumberOfHuffmanCodes] ;
  sumPprFreq = new uint [PngMaxNumberOfHuffmanCodes] ;
  ehufsi = new UBYTE1 [PngMaxNumberOfHuffmanCodes];
  buffer= new UBYTE1[CompressedBufferSize+5];
  bufFreq = new UBYTE1 [PngMaxNumberOfHuffmanCodes];

  StartEncode() ;
  return ;
}

ACEncoder::~ACEncoder ()
{
  delete [] freq ; freq = NULL ;
  delete [] sumPprFreq ; sumPprFreq = NULL;
  delete [] ehufsi ; ehufsi = NULL ;
  delete [] buffer ; buffer = NULL ;
  delete [] bufFreq ; bufFreq = NULL;
  return ;
}

void ACEncoder::StartEncode()
{
  pozBuffer=0;
  pozBufFreq=0;
  pozBitFreq=0;
  bufFreq[0]=0;
  nayavnoCode=false;
  memset (freq, 0, sizeof (*freq) * PngMaxNumberOfHuffmanCodes);
  low=FFNum=Cache=0;  range=(uint)-1;
  return ;
}

void ACEncoder::IncrementFrequency (uint value)
{
  if (value >= PngMaxNumberOfHuffmanCodes)
    throw EPngError ("Index out of range") ;

  ++ freq[value] ;
  return ;
}

//      [0; 2^15-1]         
//
void ACEncoder::BuildTable ()
 {UBYTE4 sumFreq=0;
  UBYTE1 lenCode;
  uint i, j;
  memset (ehufsi, 0, sizeof (UBYTE1) * PngMaxNumberOfHuffmanCodes) ;
  memset (sumPprFreq, 0, sizeof (UBYTE4) * PngMaxNumberOfHuffmanCodes) ;
  for (i = 0 ; i < PngMaxNumberOfHuffmanCodes ; ++i)
   sumFreq+=freq[i];
  if (sumFreq==0)
   return;
  nayavnoCode=true; 
  double mnog=(double)lenRange/sumFreq;
  uint maxFreq=0, indexMaxFreq=0;
  sumFreq=0;
  if (mnog<1)
   {for (i = 0 ; i < PngMaxNumberOfHuffmanCodes ; ++i)
     if (freq[i]>0)
      {freq[i]*=mnog;
       if (!freq[i])
        freq[i]=1;
       else
        if (freq[i]>maxFreq)
         {maxFreq=freq[i];
          indexMaxFreq=i;
         }
       sumFreq+=freq[i];
      }
   }
  else
   {for (i = 0 ; i < PngMaxNumberOfHuffmanCodes ; ++i)
     if (freq[i]>0)
      {freq[i]*=mnog;
       if (freq[i]>maxFreq)
        {maxFreq=freq[i];
         indexMaxFreq=i;
        }
       sumFreq+=freq[i];
      }
   }
  freq[indexMaxFreq]+=lenRange-sumFreq;
  if (freq[indexMaxFreq]==lenRange)
   freq[indexMaxFreq]--; //    
  //  ,           
  sumFreq=0;
  for (i = 0 ; i < PngMaxNumberOfHuffmanCodes ; ++i)
   if (freq[i]>0)
    {sumPprFreq[i]=sumFreq;
     sumFreq+=freq[i];
     lenCode=countBit(freq[i]);
     ehufsi[i]=lenCode;
     for (j = 0 ; j < lenCode-1 ; ++j)
      {if ((freq[i] & (1 << j)) != 0)
        bufFreq[pozBufFreq] |= (1 << pozBitFreq) ;
       ++pozBitFreq;
       if (pozBitFreq >= 8)
        {pozBufFreq++;
         bufFreq[pozBufFreq]=0;
         pozBitFreq=0;
        }
      }
    }
  if (pozBitFreq)
   pozBufFreq++;
  return;
}

inline void ACEncoder::putByte(unsigned char s)
 {buffer[pozBuffer++]=s;
 }

inline void ACEncoder::ShiftLow()
 {
       	if ( (low>>24)!=0xFF )
         {putByte ( Cache + (low>>32));
          if (FFNum)
           {int c = 0xFF+(low>>32);
	    while( FFNum ) putByte(c), FFNum--;
           }
	  Cache = uint(low)>>24;
	 }
        else
         FFNum++;
	low = uint(low)<<8;
 }

void ACEncoder::Encode (uint value)
 {if (value >= PngMaxNumberOfHuffmanCodes)
   throw EPngError ("Index Out of Range");
  if (ehufsi [value] == 0)
   {value=value;
    throw EPngError ("INTERNAL ERROR - Missing Arifmetic Code") ;
   }
  low += sumPprFreq[value] * (range>>=15);
  range*= freq[value];
  while( range<TOP ) ShiftLow(), range<<=8;
 }

void ACEncoder::FinishEncode()
 {low+=1;
  DO(5) ShiftLow();
 }

//   
bitBufferOutput::bitBufferOutput ()
 {buffer= new UBYTE1[CompressedBufferSize+5];
  StartOutput() ;
  return ;
 }

bitBufferOutput::~bitBufferOutput ()
 {delete [] buffer ; buffer = NULL ;
  return ;
 }

void bitBufferOutput::StartOutput()
 {pozBuffer=0;
  pozBitBuffer=0;
  buffer[0]=0;
  return ;
 }

void bitBufferOutput::OutputBit (unsigned int data, unsigned int length)
 {for (UBYTE1 j = 0; j < length; ++j)
   {if ((data & (1 << j)) != 0)
     buffer[pozBuffer] |= (1 << pozBitBuffer);
    ++pozBitBuffer;
    if (pozBitBuffer >= 8)
     {pozBuffer++;
      buffer[pozBuffer]=0;
      pozBitBuffer=0;
     }
   }
  return;
 }




